#include "monkey.h"
#include <stdio.h>
#include <string.h>

/* This routine will do some simple permutations on the password string
   such as converting to all upper-case, all lower case, etc */

int mod_passwd(victim *john, int counter){

   int j, i, same=0;
   char tmp_char;

   switch (counter){

        case 0: /* Try the username */
           strcpy(john->m_passwd, john->username);
           break;

        case 1: /* Try the username backwards */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd) -1;
           for (i=0; i<j; i++, j--){
              tmp_char = john->m_passwd[i];
              john->m_passwd[i] = john->m_passwd[j];
              john->m_passwd[j] = tmp_char;
           }
	   if (memcmp(john->m_passwd, john->username, strlen(john->username))
	      == 0)
	      same = 1;
           break;

        case 2: /* Try the username with the first letter Capitalized */
           strcpy(john->m_passwd, john->username);
           john->m_passwd[0] = toupper(john->m_passwd[0]);
	   if (memcmp(john->m_passwd, john->username, strlen(john->username))
	      == 0)
	      same = 1;
           break;

        case 3: /* Try the username with '1' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '1';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 4: /* Try the username with '2' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '2';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 5: /* Try username with '3' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '3';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 6: /* Try username with '4' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '4';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 7: /* Try username with '5' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '5';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 8: /* Try username with '6' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '6';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 9: /* Try username with '7' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '7';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 10: /* Try username with '8' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '8';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 11: /* Try username with '9' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '9';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 12: /* Try username with '0' appended to it */
           strcpy(john->m_passwd, john->username);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '0';
              john->m_passwd[j+1] = '\0';
           }
	   else 
	      same = 1;
           break;

        case 13: /* use the password as we grabbed it */
           strcpy(john->m_passwd, john->passwd);
           break;

        case 14: /* Try all CAPS password */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd) -1;
           for (i=0; i<= j; i++)
              john->m_passwd[i] = toupper(john->passwd[i]);
	   if (memcmp(john->m_passwd, john->passwd, strlen(john->passwd))
	      == 0)
	      same = 1;
           break;

        case 15: /* Try all lower-case password */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd) -1;
           for (i=0; i<=j; i++)
              john->m_passwd[i] = tolower(john->m_passwd[i]);
	   if (memcmp(john->m_passwd, john->passwd, strlen(john->passwd))
	      == 0)
	      same = 1;
           break;

        case 16: /* Try the password backwards */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd) -1;
           for (i=0; i<j; i++, j--){
              tmp_char = john->m_passwd[i];
              john->m_passwd[i] = john->m_passwd[j];
              john->m_passwd[j] = tmp_char;
           }
	   if (memcmp(john->m_passwd, john->passwd, strlen(john->passwd))
	      == 0)
	      same = 1;
           break;

        case 17: /* Try the password with the first letter Capitalized */
           strcpy(john->m_passwd, john->passwd);
           john->m_passwd[0] = toupper(john->m_passwd[0]);
	   if (memcmp(john->m_passwd, john->passwd, strlen(john->passwd))
	      == 0)
	      same = 1;
           break;

        case 18: /* Try passwd with '1' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '1';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 19: /* Try passwd with '2' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '2';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 20: /* Try passwd with '3' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '3';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 21: /* Try passwd with '4' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '4';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 22: /* Try passwd with '5' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '5';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 23: /* Try passwd with '6' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '6';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 24: /* Try passwd with '7' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '7';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 25: /* Try passwd with '8' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '8';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 26: /* Try passwd with '9' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '9';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 27: /* Try passwd with '0' appended to it */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd);
           if (j < MAXSIZE -1){
              john->m_passwd[j] = '0';
              john->m_passwd[j+1] = '\0';
           }
	   else
	      same = 1;
           break;

        case 28: /* try some common substitutions */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd) -1;
           for (i=0; i<=j; i++){
              if (john->m_passwd[i] == 's' || john->m_passwd[i] == 'S')
                 john->m_passwd[i] = '$';
           }
	   if (memcmp(john->m_passwd, john->passwd, strlen(john->passwd))
	      == 0)
	      same = 1;
           break;

        case 29: /* try some common substitutions */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd) -1;
           for (i=0; i<=j; i++){
              if (john->m_passwd[i] == 'i' || john->m_passwd[i] == 'I')
                 john->m_passwd[i] = '!';
           }
	   if (memcmp(john->m_passwd, john->passwd, strlen(john->passwd))
	      == 0)
	      same = 1;
           break;

        case 30: /* try some common substitutions */
           strcpy(john->m_passwd, john->passwd);
           j = strlen(john->m_passwd) -1;
           for (i=0; i<=j; i++){
              if (john->m_passwd[i] == 'o' || john->m_passwd[i] == 'O')
                 john->m_passwd[i] = '0';
           }
	   if (memcmp(john->m_passwd, john->passwd, strlen(john->passwd))
	      == 0)
	      same = 1;
           break;

        default:
           /* for safety sake try to copy 'something' into m_passwd
              so we aren't passing around NULL strings or garbage */
           strcpy(john->m_passwd, "ERROR");
           break;

   } /* end switch */

   return same;
}
